## org.apache.poi.hssf.record
Class ExternSheetRecord

    java.lang.Object
      org.apache.poi.hssf.record.Record
          org.apache.poi.hssf.record.ExternSheetRecord

public class ExternSheetRecord
extends Record

Title: Extern Sheet

Description: A List of Inndexes to SupBook

REFERENCE:

Version:
  1.0-pre
Author:
  Libin Roman (Vista Portal LDT. Developer)

Field Summary
`static short` `sid`

Constructor Summary
`ExternSheetRecord()`
`ExternSheetRecord(short id, short size, byte[] data)` Constructs a Extern Sheet record and sets its fields appropriately.
`ExternSheetRecord(short id, short size, byte[] data, int offset)` Constructs a Extern Sheet record and sets its fields appropriately.

Method Summary
`void` `addREFRecord(ExternSheetSubRecord rec)` adds REF struct (ExternSheetSubRecord)
`protected void` `fillFields(byte[] data, short size, int offset)` called by the constructor, should set class level fields.
`int` `getNumOfREFRecords()` returns the number of REF Records, which is in model
`short` `getNumOfREFStructures()` return the number of the REF structors , that is in Excel file
`int` `getRecordSize()` gives the current serialized size of the record.
`ExternSheetSubRecord` `getREFRecordAt(int elem)` returns the REF record (ExternSheetSubRecord)
`short` `getSid()` return the non static version of the id for this record.
`int` `serialize(int offset, byte[] data)` called by the class that is responsible for writing this sucker.
`void` `setNumOfREFStructures(short numStruct)` sets the number of the REF structors , that is in Excel file
`java.lang.String` `toString()` get a string representation of the record (for biffview/debugging)
`protected void` `validateSid(short id)` called by constructor, should throw runtime exception in the event of a record passed with a differing ID.

Methods inherited from class org.apache.poi.hssf.record.Record
`clone, fillFields, isInValueSection, isValue, processContinueRecord, serialize`

Methods inherited from class java.lang.Object
`equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Field Detail

### sid

    public static final short sid

See Also:
  Constant Field Values

Constructor Detail

### ExternSheetRecord

    public ExternSheetRecord()

### ExternSheetRecord

    public ExternSheetRecord(short id,
                             short size,
                             byte[] data)

  Constructs a Extern Sheet record and sets its fields appropriately.

Parameters:
  `id` - id must be 0x16 or an exception will be throw upon validation
  `size` - the size of the data area of the record
  `data` - data of the record (should not contain sid/len)

### ExternSheetRecord

    public ExternSheetRecord(short id,
                             short size,
                             byte[] data,
                             int offset)

  Constructs a Extern Sheet record and sets its fields appropriately.

Parameters:
  `id` - id must be 0x16 or an exception will be throw upon validation
  `size` - the size of the data area of the record
  `data` - data of the record (should not contain sid/len)
  `offset` - of the record's data

Method Detail

### validateSid

    protected void validateSid(short id)

  called by constructor, should throw runtime exception in the event of a record passed with a differing ID.

  Specified by:
    `validateSid` in class `Record`
  Parameters:
    `id` - alleged id for this record

### fillFields

    protected void fillFields(byte[] data,
                              short size,
                              int offset)

  called by the constructor, should set class level fields. Should throw runtime exception for bad/icomplete data.

  Specified by:
    `fillFields` in class `Record`
  Parameters:
    `data` - raw data
    `size` - size of data
    `offset` - of the record's data (provided a big array of the file)

### setNumOfREFStructures

    public void setNumOfREFStructures(short numStruct)

  sets the number of the REF structors , that is in Excel file

  Parameters:
    `numStruct` - number of REF structs

### getNumOfREFStructures

    public short getNumOfREFStructures()

  return the number of the REF structors , that is in Excel file

  Returns:
    number of REF structs

### addREFRecord

    public void addREFRecord(ExternSheetSubRecord rec)

  adds REF struct (ExternSheetSubRecord)

  Parameters:
    `rec` - REF struct

### getNumOfREFRecords

    public int getNumOfREFRecords()

  returns the number of REF Records, which is in model

  Returns:
    number of REF records

### getREFRecordAt

    public ExternSheetSubRecord getREFRecordAt(int elem)

  returns the REF record (ExternSheetSubRecord)

  Parameters:
    `elem` - index to place
  Returns:
    REF record

### toString

    public java.lang.String toString()

  Description copied from class: `Record`
  get a string representation of the record (for biffview/debugging)

  Overrides:
    `toString` in class `Record`

### serialize

    public int serialize(int offset,
                         byte[] data)

  called by the class that is responsible for writing this sucker. Subclasses should implement this so that their data is passed back in a byte array.

  Specified by:
    `serialize` in class `Record`
  Parameters:
    `offset` - to begin writing at
    `data` - byte array containing instance data
  Returns:
    number of bytes written

### getRecordSize

    public int getRecordSize()

  Description copied from class: `Record`
  gives the current serialized size of the record. Should include the sid and reclength (4 bytes).

  Overrides:
    `getRecordSize` in class `Record`

### getSid

    public short getSid()

  return the non static version of the id for this record.

  Specified by:
    `getSid` in class `Record`

Copyright © 2003 Apache Software Foundation.